



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【WPF】样式与模板：鼠标移入/悬浮时按钮的背景色不改变</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【WPF】样式与模板：鼠标移入/悬浮时按钮的背景色不改变</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 07:33:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>情况：鼠标移到按钮上，默认情况是按钮背景色会改变的，网上也能搜到很多如何自定义改变的背景色。</p>
<p>需求：现在需求反过来，想要鼠标移到按钮上，保持按钮的背景色不改变。</p>
<p>一种思路：在样式文件中，使用MultiTrigger来定义按钮的【鼠标悬浮+不被选中/被选中】同时满足的状态时的背景色。</p>
<p>解决：自定义一个ToggleButton的样式文件。 <br />
MyToggleButton.xaml：</p>
<pre class="prettyprint linenums"><code>&lt;ResourceDictionary  x:Class="HomeDecorationPSD.Presentation.Style.MyToggleButton"<br />
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"<br />
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"<br />
        xmlns:d="http://schemas.microsoft.com/expression/blend/2008"<br />
        xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"<br />
        xmlns:local="clr-namespace:HomeDecorationPSD.Presentation.Style"<br />
        mc:Ignorable="d"&gt;

    &lt;Style x:Key="myToggleButton" TargetType="{x:Type ToggleButton}"&gt;<br />
        &lt;Setter Property="Width" Value="60"/&gt;<br />
        &lt;Setter Property="Height" Value="20"/&gt;<br />
        &lt;!-- 替换掉默认的模板 --&gt;<br />
        &lt;Setter Property="Template"&gt;<br />
            &lt;Setter.Value&gt;<br />
                &lt;ControlTemplate TargetType="{x:Type ToggleButton}"&gt;<br />
                    &lt;Border CornerRadius="3" BorderThickness="1" Background="{TemplateBinding Background}" BorderBrush="{TemplateBinding BorderBrush}"&gt;<br />
                        &lt;ContentPresenter HorizontalAlignment="Center" VerticalAlignment="Center"/&gt;<br />
                    &lt;/Border&gt;<br />
                &lt;/ControlTemplate&gt;<br />
            &lt;/Setter.Value&gt;<br />
        &lt;/Setter&gt;<br />
        &lt;Style.Triggers&gt;<br />
            &lt;!-- 更改三态的背景颜色 --&gt;<br />
            &lt;Trigger Property="IsChecked" Value="true"&gt;<br />
                &lt;Setter Property="Background" Value="#FFA1C3F3"/&gt;<br />
            &lt;/Trigger&gt;<br />
            &lt;Trigger Property="IsChecked" Value="false"&gt;<br />
                &lt;Setter Property="Background" Value="#FF14B3FD"/&gt;<br />
            &lt;/Trigger&gt;<br />
            &lt;!-- 鼠标悬浮时，背景颜色不变 --&gt;<br />
            &lt;MultiTrigger&gt;<br />
                &lt;MultiTrigger.Conditions&gt;<br />
                    &lt;Condition Property="IsMouseOver" Value="true"/&gt;<br />
                    &lt;Condition Property="IsChecked" Value="true"/&gt;<br />
                &lt;/MultiTrigger.Conditions&gt;<br />
                &lt;MultiTrigger.Setters&gt;<br />
                    &lt;Setter Property="Background" Value="#FFA1C3F3"/&gt;<br />
                &lt;/MultiTrigger.Setters&gt;<br />
            &lt;/MultiTrigger&gt;<br />
            &lt;MultiTrigger&gt;<br />
                &lt;MultiTrigger.Conditions&gt;<br />
                    &lt;Condition Property="IsMouseOver" Value="true"/&gt;<br />
                    &lt;Condition Property="IsChecked" Value="false"/&gt;<br />
                &lt;/MultiTrigger.Conditions&gt;<br />
                &lt;MultiTrigger.Setters&gt;<br />
                    &lt;Setter Property="Background" Value="#FF14B3FD"/&gt;<br />
                &lt;/MultiTrigger.Setters&gt;<br />
            &lt;/MultiTrigger&gt;<br />
        &lt;/Style.Triggers&gt;<br />
    &lt;/Style&gt;<br />
&lt;/ResourceDictionary&gt;<br />
</code></pre>
<p>给ToggleButton使用这个样式：</p>
<pre class="prettyprint linenums"><code>&lt;UserControl<br />
        x:Class="HomeDecorationPSD.Presentation.Views.SpaceView"<br />
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"<br />
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"<br />
        xmlns:d="http://schemas.microsoft.com/expression/blend/2008"<br />
        xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"<br />
        xmlns:vm="clr-namespace:HomeDecorationPSD.Applications.ViewModels"<br />
        mc:Ignorable="d" MinWidth="300" MinHeight="500"<br />
        &gt;<br />
    &lt;!-- 引入样式文件 --&gt;<br />
    &lt;UserControl.Resources&gt;<br />
        &lt;ResourceDictionary&gt;<br />
            &lt;ResourceDictionary.MergedDictionaries&gt;<br />
                &lt;ResourceDictionary Source="/Presentation/Style/MyToggleButton.xaml" /&gt;&lt;!-- 是工程的相对路径 --&gt;<br />
            &lt;/ResourceDictionary.MergedDictionaries&gt;<br />
        &lt;/ResourceDictionary&gt;<br />
    &lt;/UserControl.Resources&gt;

    &lt;DockPanel Margin="10" &gt;<br />
        &lt;StackPanel Orientation="Vertical"&gt;<br />
        &lt;WrapPanel Orientation="Horizontal" Margin="5"&gt;<br />
                &lt;ToggleButton Content="客餐厅" IsChecked="True" Style="{StaticResource myToggleButton}" Margin="5"/&gt;<br />
                &lt;ToggleButton Content="客厅" Style="{StaticResource myToggleButton}" Margin="5"/&gt;<br />
                &lt;ToggleButton Content="餐厅" Style="{StaticResource myToggleButton}" Margin="5"/&gt;<br />
                &lt;ToggleButton Content="卧室" Style="{StaticResource myToggleButton}" Margin="5"/&gt;<br />
                &lt;ToggleButton Content="测试" Style="{StaticResource myToggleButton}" Margin="5"/&gt;<br />
            &lt;/WrapPanel&gt;<br />
        &lt;/StackPanel&gt;<br />
    &lt;/DockPanel&gt;<br />
&lt;/UserControl&gt;</code></pre>
<p>运行效果： <br />
<img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161210102746155?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvcXFfMTg5OTU1MTM=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" /></p>
<p>小结：</p>
<ol><li>如果不给Style指定一个x:Key值，则所有的ToggleButton都会变成使用该样式。为了避免这种情况，使用x:Key值来指定用哪个样式，否则是默认样式。 <br />
关于WPF样式的学习参考这篇文章：<a href="http://www.cnblogs.com/zhouyinhui/archive/2007/03/27/690431.html" rel="external nofollow noreferrer">http://www.cnblogs.com/zhouyinhui/archive/2007/03/27/690431.html</a></li>
<li>为什么要用上Template模板，居然在某度知道看到答案：<a href="https://zhidao.baidu.com/question/2137628503185830468.html" rel="external nofollow noreferrer">https://zhidao.baidu.com/question/2137628503185830468.html</a></li></ol>
</div>
<hr />
<p>2018.3.25更新：</p>
<p>参考这个办法：<a href="https://blog.csdn.net/qian_f/article/details/28886021" rel="external nofollow noreferrer">https://blog.csdn.net/qian_f/article/details/28886021</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxemv08.html">C&plus;&plus;小项目：directx11图形程序（四）：d3dclass</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx07pzq.html">shellinabox安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeexy09.html">ARPG客户端中场景对象体系设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmdpwe9.html">sublime自己常用到的设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmrjd19.html">bzoj4171 or 省队集训day3 chess&colon; Rhl的游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd1gdl8.html">GDAL 生成shp文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pg01v8.html">C&sol;C&plus;&plus;中&lowbar;&lowbar;builtin&lowbar;popcount&lpar;&rpar;的使用及原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj04169.html">最简单的视频编码器：基于libx264（编码YUV为H&period;264）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m671n8.html">spring&period;http&period;multipart&period;maxFileSize提示无效报错问题处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp6v1xq.html">Linux之文件权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvjozr8.html">python web编程之网络基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j115109.html">Spring Boot入门（12）实现页面访问量统计功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7onmmj8.html">HTTP请求头信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1okelq.html">AI 循环神经网络</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjv1r49.html">visual studio Lua 调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r6xk68.html">mycat下mysql jdbc connector使用高版本报PacketTooBigException异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll46k1q.html">浅谈XSS攻击原理与解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjxwy79.html">clientdataset&period;open 报错  Name not unique in this context</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pgk30q.html">jqgrid 分页时，清空原表格数据加载返回的新数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p4gnjq.html">golang-defer坑的本质</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9ppy7479.html">opencv-3&period;0&period;0-beta和opencv2版本号的差别</a>
			</li>
						<li><a href="https://www.batexi.com/a/953v70v8.html">Apache POI &ndash; Reading and Writing Excel file in Java</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql12xwk9.html">NYOJ-------三角形</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlexkk9.html">【LeetCode】24&period; Swap Nodes in Pairs &lpar;3 solutions&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kol403q.html">【LeetCode】132&period; Palindrome Partitioning II</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlexxz9.html">POJ  2965  The Pilots Brothers&amp;&num;39&semi; refrigerator （DFS）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlexgy9.html">android 手机红外遥控器实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vnog4q.html">Linux内核同步 - Seqlock</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj3vo7q.html">Leet Code -- Unique BST</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ew1y19.html">Python len&lpar;&rpar; 方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
